<?php

/*
recess.php 2009-04-10
john@handelaar.org
*/

/* Dail */
$GLOBALS['recessdates'][1] = array(
	2007 => array(
		6=>array('less'=>14),
		7=>array('more'=>5),
		8=>array('all'=>1),
		9=>array('less'=>26),
		12=>array('more'=>19),
	),
	2008 => array(
		1=>array('less'=>30),
		3=>array('more'=>13),
		6=>array('between'=>array(6,16)),
		7=>array('more'=>10),
		8=>array('all'=>1),
		9=>array('less'=>24),
		12=>array('more'=>18),
	),
	2009 => array(
		1=>array('less'=>20),
		3=>array('between'=>array(13,23)),
		4=>array('between'=>array(10,21)),
	),
);

/*
function currently_in_recess() {
    // Main file which recesswatcher.py overwrites each day
    $h = fopen(RECESSFILE, "r");
    $today = date("Y-m-d");
    while ($line = fgets($h)){
        list($name, $from, $to) = split(",", $line);
        if ($from <= $today and $today <= $to) {
            return array($name, trim($from), trim($to));
        }
    }
    // Second manual override file
    $h = fopen(RECESSFILE.".extra", "r");
    while ($line = fgets($h)){
        list($name, $from, $to) = split(",", $line);
        if ($from <= $today and $today <= $to) {
            return array($name, trim($from), trim($to));
        }
    }
    return false;
}
*/

function recess_prettify($day, $month, $year, $body) {
	global $recessdates;
	$dates = $recessdates[$body];
	$recess = 0; $from = ''; $to = '';
	if (isset($dates[$year][$month]['all'])) {
		$recess = 'Summer Recess';
		if (isset($dates[$year][7]['all'])) {
			$from = "$year-6-" . $dates[$year][6]['more'];
		} else {
			$from = "$year-7-" . $dates[$year][7]['more'];
		}
		if (!isset($dates[$year][9]))
			$to = "$year-08-31";
		elseif (isset($dates[$year][9]['all']))
			$to = "$year-10-" . $dates[$year][10]['less'];
		else
			$to = "$year-9-" . $dates[$year][9]['less'];
	}
	if ( (isset($dates[$year][$month]['less']) && $day < $dates[$year][$month]['less'])
	|| (isset($dates[$year][$month]['more']) && $day > $dates[$year][$month]['more'])
	|| (isset($dates[$year][$month]['between']) && $day > $dates[$year][$month]['between'][0] && $day < $dates[$year][$month]['between'][1])
	|| (isset($dates[$year][$month]['between'][2]) && $day > $dates[$year][$month]['between'][2] && $day < $dates[$year][$month]['between'][3]) ) {
		switch ($month) {
			case 1: case 12: $recess = 'Christmas Recess'; break;
			case 2: if ($body==1) $recess = 'Half Term Week';
				elseif ($body==4) $recess = 'February Recess';
				break;
			case 3: if ($body==1) $recess = 'Easter Recess';
				elseif ($body==4) $recess = 'Spring Recess';
				break;
			case 4: if (isset($dates[$year][$month]['more']) && $day > $dates[$year][$month]['more']) {
					$recess = 'Election Recess';
				} elseif ($body==4 && $year==2003) {
					$recess = 'Election Recess';
				} elseif ($body==1) {
					$recess = 'Easter Recess';
				} elseif ($body==4) {
					$recess = 'Spring Recess';
				}
				break;
			case 5: if ($year==2001 || (isset($dates[$year][$month]['less']) && $day < $dates[$year][$month]['less'])) {
					$recess = 'Election Recess';
				} else {
					$recess = 'Whit Recess';
				}
				break;
			case 6: if ($year==2001) {
					$recess = 'Election Recess';
				} elseif ($body==1) {
					$recess = 'Whit Recess';
				} elseif ($body==4) {
					$recess = 'Summer Recess';
				} else {
					trigger_error("Argh6");
				}
				break;
			case 7: case 8: $recess = 'Summer Recess';
				break;
			case 9: if (isset($dates[$year][$month]['less']) && $day < $dates[$year][$month]['less']) {
					$recess = 'Summer Recess';
				} elseif ($body==1) {
					$recess = 'Conference Recess';
				} else {
					trigger_error("Argh9");
				}
				break;
			case 10: if ($body==1) $recess = 'Conference Recess';
				elseif ($body==4) $recess = 'Autumn Recess';
				break;
			default: $recess = 1;
		}
		if (isset($dates[$year][$month]['less']) && $day < $dates[$year][$month]['less']) {
			$to = "$year-$month-" . $dates[$year][$month]['less'];
			if ($month==1)
				$from = ($year-1)."-12-" . $dates[$year-1][12]['more'];
			else {
				for ($newmonth = $month-1; $newmonth>=1; $newmonth--) {
					if (isset($dates[$year][$newmonth]['more'])) {
						$from = "$year-".($newmonth)."-" . $dates[$year][$newmonth]['more'];
						break;
					}
				}
			}
		}
		if (isset($dates[$year][$month]['more']) && $day > $dates[$year][$month]['more']) {
			$from = "$year-$month-" . $dates[$year][$month]['more'];
			if ($month==12)
				$to = ($year+1)."-01-" . $dates[$year+1][1]['less'];
			else {
				for ($newmonth = $month+1; $newmonth<=12; $newmonth++) {
					if (isset($dates[$year][$newmonth]['less'])) {
						$to = "$year-".($newmonth)."-" . $dates[$year][$newmonth]['less'];
						break;
					}
				}
			}
		}
		if (isset($dates[$year][$month]['between']) && $day > $dates[$year][$month]['between'][0] && $day < $dates[$year][$month]['between'][1]) {
			$from = "$year-$month-" . $dates[$year][$month]['between'][0];
			$to = "$year-$month-" . $dates[$year][$month]['between'][1];
		}
		if (isset($dates[$year][$month]['between'][2]) && $day > $dates[$year][$month]['between'][2] && $day < $dates[$year][$month]['between'][3]) {
			$from = "$year-$month-" . $dates[$year][$month]['between'][2];
			$to = "$year-$month-" . $dates[$year][$month]['between'][3];
		}
	}
	return array($recess, $from, $to);
}

